/* HRule, Draw an horizontal rule (3D look)
 * copyright (c) 1998 Alexis de Bernis
 */

import java.awt.*;
import java.util.Vector;



class HRule extends Panel
{
    int width,depth,Xmargin,Ymargin;


    HRule(int width,int depth,int Xmargin,int Ymargin)
    {
        super();

        this.width=width;
        this.depth=depth;
        this.Xmargin=Xmargin;
        this.Ymargin=Ymargin;
    
    }

    public void paint(Graphics g)
    {
        Color bg=getBackground();
        g.setColor(bg.darker());

        for(int i=0;i<depth;i++)
            g.drawLine(Xmargin,Ymargin+i,Xmargin+width,Ymargin+i);

        g.setColor(bg.brighter());

        for(int i=0;i<depth;i++)
            g.drawLine(Xmargin,i+depth+Ymargin,Xmargin+width,i+depth+Ymargin);
    }

    public Dimension getPreferredSize()
    {
        return(new Dimension(width+2*Xmargin,2*depth+2*Ymargin));
    }

    public Dimension getMinimumSize()
    {
        return(new Dimension(width+2*Xmargin,2*depth+2*Ymargin));
    }

    public Dimension getMaximumSize()
    {
        return(new Dimension(width+2*Xmargin,2*depth+2*Ymargin));
    }
}
