/* NessusJ
 * Copyright (C) 1998 Alexis de Bernis
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This class defines an host. It's also a component that can be
 * integrated into a list.
 *
 *  Please run class NessusJ instead.
 */


import java.lang.*;
import java.util.*;
import java.awt.*;
import com.sun.java.swing.*;
import java.awt.event.*;
import com.sun.java.swing.border.*;


class Host extends JPanel implements ActionListener
{

    JButton stop,nameToClick;
    JProgressBar info;
    String cur="0",max="0",phase,curNum;
    private String name;
    private Vector openPorts,holes,infos;
    int holeCount=0,infoCount=0;
    boolean portScanning=true,first=true;

    Host(String name)
    {
        super(new FlowLayout(FlowLayout.RIGHT,10,5));

        this.name=name;

        info=new JProgressBar();
        stop=new JButton("Stop");
        stop.addActionListener(this);
        nameToClick=new JButton(name);
        nameToClick.setBorder(new EmptyBorder(0,0,0,0));
        nameToClick.addActionListener(this);

        add("West",nameToClick);
        add("Center",info);
        add("East",stop);
        setBorder(new EtchedBorder());

        openPorts=new Vector();
        holes=new Vector();
        infos=new Vector();

    }

    public String getName()
    {
        return(name);
    }

    public Vector getOpenPorts()
    {
        return(openPorts);
    }

    public Vector getHoles()
    {
        return(holes);
    }

    public Vector getInfos()
    {
        return(infos);
    }

    public void addOpenPort(Integer open)
    {
        openPorts.addElement(open);
    }

    public void addHole(Hole hole)
    {
        holes.addElement(hole);
        holeCount=holeCount+1;
    }

    public void addInfo(Info info)
    {
        infos.addElement(info);
        infoCount=infoCount+1;
    }

    public int getInfoCount()
    {
        return(infoCount);
    }

    public int getHoleCount()
    {
        return(holeCount);
    }

    public void setInfo(String current)
    {
        String temp=current.substring(current.indexOf("/")+1,current.length());
        info.setValue(Integer.parseInt(current.substring(0,current.indexOf("/"))));

        if(first)
        {
            curNum=temp;
            first=false;
            info.setMaximum(Integer.parseInt(temp));
            return;
        }

        if(!curNum.equals(temp))
        {
            curNum=temp;
            portScanning=false;
            phase="Launching plugins";
            info.setMaximum(Integer.parseInt(temp));
        }

    }

    public void setPhase(String current)
    {
        phase=current;
    }

    public String getPhase()
    {
        return(phase);
    }

    public boolean isPortScanning()
    {
        return(portScanning);
    }


    public void actionPerformed(ActionEvent evt)
    {
        String command=evt.getActionCommand();

        if(command.equals("Stop"))
        {
            stop.setEnabled(false);
            info.setForeground(Color.red);
            ((NessusdStatus) getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent()).stopAttack(this);
        }

        if(command.equals(name))
            ((NessusdStatus) getParent().getParent().getParent().getParent().getParent().getParent().getParent().getParent()).hostSelected(this);


    }




}

